      PROGRAM QCDPAR2_TEST
C QCD  PARAMETERS: TEST PROGRAM for qcdpar2.f
C Linkfile : qcdpar2
      IMPLICITREAL *8(A-Z)
      character *1 cfn(4)
      INTEGER I,II,J,K,NF0,NFS,FTQ,IOR,nfx
      INTEGER N
      REAL *8 M2Q(6)
      REAL *8 AS(6),LA(6),RP(6),RM(6),RR(6,6),MS(6),TT(6)
      COMMON /ASETC/ AS,LA,RP,RM,RR,MS,TT
      common/var/pi,ALINP,EINP,MTOP,FTQ,IOR
      data cfn /'1','2','3','4'/
C Input: Quark masses MQ and physical thresholds TH for switching NF from rqcd-param.f
      integer IER
      double precision pi1,ALINP1,EINP1,MTOP1,ERALS
      DOUBLE PRECISION MQ(6),MP(6),TH(6),dmp(6,3)
      common /inp/pi1,ALINP1,EINP1,MTOP1
      COMMON /QUARK/MQ,MP,TH
      common /QUAER/ERALS,IER
      common /QUAME/DMP

      call rqcdparam()          ! fill common inp,QUARK etc; updated April 2008 and 2012
c now as interface to constants_qcd
      pi   =pi1
      alinp=ALINP1
      einp =EINP1
      alerr=ERALS
      MTOP =MTOP1
*
*     .. Executable Statements ..
*       
c7      FORMAT(1X ,2X,' Topmass MTOP, strong coupling ALINP at EINP :'/
c     1 ,3X,' Test-range: EMIN,EMAX,N (Anzahl Punkte)'/
c     1 ,3X,' FTQ=0:fixed threshold mass'/
c     1 ,3X,' FTQ=1:running mass with threshold
c     &  at 2*MP=2*MQ*root(1+8/3*al/pi)'/
c     1 ,3X,' FTQ=2:running mass with threshold at 2*MQ'/
c     1 ,3X,' # IOR=0,1,2,3 order of perturbation theory '/
c     1 ,3X,' # if IOR=0 QCD parameters fixed at 1GeV and AS=0'/
c     1 ,3X,' # enter MTOP,ALINP,EINP,EMIN,EMAX,N,FTQ,IOR'/)
c       WRITE(*,7)
C       READ(*,*) MTOP,ALINP,EINP,EMIN,EMAX,N,FTQ,IOR
* specify energy range here
       emin=1.d0
       emax=100.d0
       n=100
       ior=2
       ftq=2
       eps=1.d-6
       WRITE(*,*) ' IOR=?'
       READ(*,*) IOR 
       
       OPEN(UNIT=1,FILE='qcdpar2_alsi.ou'//cfn(ior),STATUS='NEW')
C
 8     FORMAT (2X,' qcdpar2 ',' MTOP:',F6.1,2X,
     .    'ALINP:',F6.3,2X,'EINP:',F6.2, '  FTQ:',I1,'  IOR:',I1)
 9     FORMAT (1X ,F10.2,3(2X,F9.4))
10     FORMAT (1X ,F10.2,2(1X,F9.4),1X,I2,2(1x,e11.4))
11     FORMAT (2X,' m_c:',F6.2,2X,' m_b:',F6.2,2X,' m_t:',F8.2)
12     format(1x,1pe11.4,3(2x,1pe11.4))

       WRITE (1,*) '      6.00000'
       WRITE (1,*) '      1.00000'
       WRITE (1,*) ' ',FLOAT(N)
       WRITE (1,*) ' Results obtained running qcdpar2'
       WRITE(1,8) MTOP,ALINP,EINP,FTQ,IOR
       WRITE(1,11) mp(4),mp(5),mp(6)
C       WRITE (1,*) ' '
       WRITE (2,*) ' '
       WRITE (3,*) ' '
C       WRITE (1,*) ' E,ALS,NFS'
       WRITE (1,*) ' Log(E^2),1./ALS,1./ALS(5),NFS,able,ftes'
       WRITE (2,*) ' E,SQRT(M2Q(1)),SQRT(M2Q(4)),SQRT(M2Q(6))'
       WRITE (3,*) ' E,SQRT(M2Q(2)),SQRT(M2Q(3)),SQRT(M2Q(5))'
C       WRITE (1,*) ' '
       WRITE (2,*) ' '
       WRITE (3,*) ' '
       SMIN=EMIN**2
       SMAX=EMAX**2
       LOSU=DLOG(SMAX)
       LOSL=DLOG(SMIN)
       DLST=(LOSU-LOSL)/(N-1)
       DO 100 I=1,N
         s_old=s
         LSLT=LOSL+(I-1)*DLST
         S=DEXP(LSLT)
         E=DSQRT(S)
         T=s+(s-s_old)*eps
         call getnf(e,nfs)
         beta0=0.d0
         beta1=0.d0
         beta2=0.d0
C         beta3=0.d0
      if (ior.ge.1) then
        beta0 =  (11.d0-2.d0/3.d0*nfs)
      else
      endif
      if (ior.ge.2) then
        beta1 =  (102.d0-38.d0/3.d0*nfs)
      else
      endif
      if (ior.ge.3) then
        beta2 =  (2857.d0/2.d0-5033.d0/18.d0*nfs+325.d0/54.d0*nfs**2)
      else
      endif
C      if (ior.ge.4) then
C        beta3 = 114.23033d0-27.133944d0 * nfs + 1.5823791d0 * nfs**2 
C     &      + 0.0058566958d0 * nfs**3
C      else
C      endif
* MSbar RG 
         b1=beta1/beta0**2
         f=(4.d0*pi)/(beta0*alinp)
         lfun=exp(-0.5d0*f*(1.d0-b1/f*log(f+b1)))
         Lambda=einp*lfun
C         write (*,*) I,s,Lambda
         LL=Lambda**2
         QQ=s
         L=LOG(QQ/LL)
         F  =L
         DO J=1,6
           FIQ=L+B1*LOG(F+B1)
           F  =FIQ
         ENDDO
         asq=(4.d0*pi)/(beta0*f)
* normalized to alpha/pi 
         CALL ALQCD2(S,ALINP,EINP,MTOP,ALS,NFS,FTQ,IOR)
         CALL ALQCD2(T,ALINP,EINP,MTOP,ALX,NFX,FTQ,IOR)
         hmsb=als/(4.d0*pi)
         able=-4.d0*(beta0+beta1*hmsb+beta2*hmsb**2)*hmsb**2/s
         if (s.ne.s_old) then
           ftes=(alx-als)/(s-s_old)/eps/pi
         else
         endif
         DO II=1,6
C           CALL M2QCD(I,S,NF0,LA0,MTOP,M2Q(I),FTQ)
           CALL M2QCD2(S,ALINP,EINP,MTOP,M2Q(II),II,FTQ,IOR)
         ENDDO
C         WRITE (1,10) E,ALS,NFS
         WRITE (1,10) LSLT,1.d0/ALS,1.d0/asq,NFS,able,ftes
         WRITE (2, 9) E,SQRT(M2Q(1)),SQRT(M2Q(4)),SQRT(M2Q(6))
         WRITE (3, 9) E,SQRT(M2Q(2)),SQRT(M2Q(3)),SQRT(M2Q(5))
100    CONTINUE
* special values at tau--mass, J/Psi and Upsilon region
       S=(1.777d0)**2
       CALL ALQCD2(S,ALINP,EINP,MTOP,ALS,NFS,FTQ,IOR)
       WRITE (1,*) '     tau:E,ALS,NFS',SQRT(S),ALS,NFS
       S=(3.3d0)**2
       CALL ALQCD2(S,ALINP,EINP,MTOP,ALS,NFS,FTQ,IOR)
       WRITE (1,*) '   J/Psi:E,ALS,NFS',SQRT(S),ALS,NFS
       S=(11.d0)**2
       CALL ALQCD2(S,ALINP,EINP,MTOP,ALS,NFS,FTQ,IOR)
       WRITE (1,*) ' Upsilon:E,ALS,NFS',SQRT(S),ALS,NFS
       WRITE(4,8) MTOP,ALINP,EINP,FTQ,IOR
       WRITE (4,*) ' LA:',LA
       S=(91.1876d0)**2
       CALL ALQCD2(S,ALINP,EINP,MTOP,ALS,NFS,FTQ,IOR)
       WRITE (1,*) '     tau:E,ALS,NFS',SQRT(S),ALS,NFS
       S=(172.9d0)**2
       CALL ALQCD2(S,ALINP,EINP,MTOP,ALS,NFS,FTQ,IOR)
       WRITE (1,*) '     tau:E,ALS,NFS',SQRT(S),ALS,NFS
       STOP
       END
