      subroutine constants_qcd()
      implicit none
      integer i,j
      double precision CHPTCUT,EC,ECUT
      double precision pi,ALINP,ERRAL,EINP,MTOP,alerr

      double precision mq(6),mp(6),th(6),dmp(6,3)
      common/var1/pi,ALINP,ERRAL,EINP,MTOP
      common /quama/mq,mp,th
      common /quame/dmp
c commons needed to get R(s)
      COMMON/RCUTS/CHPTCUT,EC,ECUT
      data pi /3.141592653589793d0/
c pQCD parameters
c quark masses MSbar mq, pole mp and thresholds th me errors dmp PDG 2012 March online
      DATA MQ /0.00325D0,0.006D0,0.115D0,1.30D0,4.20D0,1.633D2/
      DATA MP /0.00325D0,0.006D0,0.115D0,1.35D0,4.40D0,1.729D2/
      DATA TH /0.99D0,0.99D0,0.99D0,3.20D0,0.96D1,3.56D2/
c      DATA MQ /0.0024D0,0.0049D0,0.100D0,1.290D0,4.190D0,163.265D0/
c      DATA MP /0.005D0,0.009D0,0.190D0,1.987D0,4.939D0,172.9D0/
cc flavor matching "thresholds" N_f -> N_f+1 
c      DATA TH /0.99D0,0.99D0,0.99D0,4.2D0,10.9D0,355.8D0/
c 1: cenral value m, 2: - dm 3: + dm  PDG 2010 TOP/MW EWWG 2012 
      DATA DMP/0.000D0,0.000D0,0.000D0,0.00D0,0.00D0,000.D0,
     &         0.000D0,0.000D0,-.020D0,-.110D0,-.060D0,-00.90D0,
     &         0.000D0,0.000D0,0.030D0,0.050D0,0.180D0,000.90D0/
      save
c these value owerwrite corresponding values set in parameters.f 
c of the Harlander-Steinhauser package rhad
* alpha-s input
      alinp= 0.1189d0
      einp =91.1876d0
      alerr= 0.001d0
      ERRAL=alerr
c      ALINP=0.1184d0 ! +/- 0.0007      S. Bethke Aug 2009, PDG 2010
c      ERRAL=0.0007d0
c      EINP=91.1876d0
      MTOP=172.9d0   ! +/- 0.6 +/- 0.9 PDG 2012 online 
c Standard cuts for pQCD in time-like regime 
c i.e. the ones used to calcuate delta alpha hadronic
      CHPTCUT=0.318d0           ! below that use CHPT
      EC=     5.2d0             ! from here to 9.5 GeV use pQCD in place of data
      ECUT=   11.5d0             ! above that pQCD tail
      return
      end
